## mirrorbits 0.5.1+git20210123.eeea0e0+ds1

=== Makefile ===
.PHONY: all build dev clean release test installdirs install uninstall install-service uninstall-service service-systemd

VERSION := $(shell git describe --always --dirty --tags)
SHA := $(shell git rev-parse --short HEAD)
BRANCH := $(subst /,-,$(shell git rev-parse --abbrev-ref HEAD))
BUILD := $(SHA)-$(BRANCH)
BINARY_NAME := mirrorbits
BINARY := bin/$(BINARY_NAME)
TARBALL := dist/mirrorbits-$(VERSION).tar.gz
TEMPLATES := templates/
ifneq (${DESTDIR}$(PREFIX),)
TEMPLATES = ${DESTDIR}$(PREFIX)/share/mirrorbits
endif
PREFIX ?= /usr/local
PACKAGE = github.com/etix/mirrorbits

LDFLAGS := -X $(PACKAGE)/core.VERSION=$(VERSION) -X $(PACKAGE)/core.BUILD=$(BUILD) -X $(PACKAGE)/config.TEMPLATES_PATH=${TEMPLATES}
GOFLAGS := -ldflags "$(LDFLAGS)"
GOFLAGSDEV := -race -ldflags "$(LDFLAGS) -X $(PACKAGE)/core.DEV=-dev"

GOPATH ?= $(HOME)/go
PROTOC_GEN_GO := $(GOPATH)/bin/protoc-gen-go

export PATH := $(GOPATH)/bin:$(PATH)

PKG_CONFIG ?= /usr/bin/pkg-config
SERVICEDIR_SYSTEMD ?= $(shell $(PKG_CONFIG) systemd --variable=systemdsystemunitdir)

all: build

$(PROTOC_GEN_GO):
	go get -u github.com/golang/protobuf/protoc-gen-go

rpc/rpc.pb.go: rpc/rpc.proto | $(PROTOC_GEN_GO) $(PROTOC)
	@ if ! which protoc > /dev/null; then \
		echo "error: protoc not installed" >&2; \
		exit 1; \
	fi
	protoc -I rpc rpc/rpc.proto --go_out=plugins=grpc:rpc

build: rpc/rpc.pb.go
	GO111MODULE=on go build $(GOFLAGS) -o $(BINARY) .

dev: rpc/rpc.pb.go
	GO111MODULE=on go build $(GOFLAGSDEV) -o $(BINARY) .

clean:
	@echo Cleaning workspace...
	@rm -f $(BINARY)
	@rm -f contrib/init/systemd/mirrorbits.service
	@rm -dRf dist

release: $(TARBALL)

test: rpc/rpc.pb.go
	GO111MODULE=on go test $(GOFLAGS) ./...

installdirs:
	mkdir -p ${DESTDIR}${PREFIX}/{bin,share} ${DESTDIR}$(PREFIX)/share/mirrorbits

install: build installdirs install-service
# For the 'make install' to work with sudo it might be necessary to add
# the Go binary path to the 'secure_path' and add 'GOPATH' to 'env_keep'.
	@cp -vf $(BINARY) ${DESTDIR}${PREFIX}/bin/
	@cp -vf templates/* ${DESTDIR}$(PREFIX)/share/mirrorbits

uninstall: uninstall-service
	@rm -vf ${DESTDIR}${PREFIX}/bin/$(BINARY_NAME)
	@rm -vfr ${DESTDIR}$(PREFIX)/share/mirrorbits

ifeq (,${SERVICEDIR_SYSTEMD})
install-service:
uninstall-service:
else
install-service: service-systemd
	install -Dm644 contrib/init/systemd/mirrorbits.service ${DESTDIR}${SERVICEDIR_SYSTEMD}/mirrorbits.service

uninstall-service:
	@rm -vf ${DESTDIR}${SERVICEDIR_SYSTEMD}/mirrorbits.service

service-systemd:
	@sed "s|##PREFIX##|$(PREFIX)|" contrib/init/systemd/mirrorbits.service.in > contrib/init/systemd/mirrorbits.service
endif

$(TARBALL): build
	@echo Packaging release...
	@mkdir -p tmp/mirrorbits
	@cp -f $(BINARY) tmp/mirrorbits/
	@cp -r templates tmp/mirrorbits/
	@cp mirrorbits.conf tmp/mirrorbits/
	@mkdir -p dist/
	@tar -czf $@ -C tmp mirrorbits && echo release tarball has been created: $@
	@rm -rf tmp

=== debian/changelog ===
mirrorbits (0.5.1+git20210123.eeea0e0+ds1-1ubuntu0.3) jammy-security; urgency=medium

  * No change rebuild due to golang-1.18 update

 -- Allen Huang <allen.huang@canonical.com>  Fri, 15 Nov 2024 22:27:39 +0000

mirrorbits (0.5.1+git20210123.eeea0e0+ds1-1ubuntu0.2) jammy-security; urgency=medium

  * No change build due to golang-1.18 update\

 -- Nishit Majithia <nishit.majithia@canonical.com>  Tue, 02 May 2023 15:01:49 +0530

mirrorbits (0.5.1+git20210123.eeea0e0+ds1-1ubuntu0.1) jammy-security; urgency=medium

  * No-change rebuild for golang-golang-x-xtext

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Wed, 01 Feb 2023 12:15:37 +0100

mirrorbits (0.5.1+git20210123.eeea0e0+ds1-1) unstable; urgency=medium

  * Initial release (Closes: #994039)

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 08 Oct 2021 15:47:32 +0200

=== debian/control ===
Source: mirrorbits
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mirrorbits Maintainers <mirrorbits@packages.debian.org>
Uploaders:
 Arnaud Rebillout <arnaudr@kali.org>,
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 golang-any,
 golang-github-coreos-go-systemd-dev,
 golang-github-gomodule-redigo-dev,
 golang-github-howeyc-gopass-dev,
 golang-github-op-go-logging-dev,
 golang-github-oschwald-maxminddb-golang-dev,
 golang-github-pkg-errors-dev,
 golang-github-rafaeljusto-redigomock-dev,
 golang-golang-x-net-dev,
 golang-google-grpc-dev,
 golang-gopkg-tylerb-graceful.v1-dev,
 golang-goprotobuf-dev,
 golang-yaml.v2-dev,
Standards-Version: 4.6.0.1
Vcs-Browser: https://salsa.debian.org/debian/mirrorbits
Vcs-Git: https://salsa.debian.org/debian/mirrorbits.git
Homepage: https://github.com/etix/mirrorbits
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/etix/mirrorbits

Package: mirrorbits
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using: ${misc:Built-Using}
Description: geographical download redirector
 Mirrorbits is a geographical download redirector written in Go for
 distributing files efficiently across a set of mirrors. It offers a simple and
 economic way to create a Content Delivery Network layer using a pure software
 stack. It is primarily designed for the distribution of large-scale
 Open-Source projects with a lot of traffic.
 .
 Main Features:
  * Blazing fast, can reach 8K QPS on a single laptop
  * Easy to deploy and maintain, everything is packed in a single binary
  * Automatic synchronization with the mirrors over rsync or FTP
  * Response can be either JSON or HTTP redirect
  * Support partial repositories
  * Complete checksum / size control
  * Realtime monitoring and reports
  * Disable misbehaving mirrors without human intervention
  * Realtime decision making based on location, AS number and defined rules
  * Smart load-balancing over multiple mirrors in the same area to avoid
    hotspots
  * Ability to adjust the weight of each mirror
  * Limit access to a country, region or ASN for any mirror
  * Clustering (multiple mirrorbits instances)
  * High-availability using redis-sentinel
  * Automatically fix timezone offsets for broken mirrors
  * Realtime statistics per file / mirror / date
  * Realtime reconfiguration
  * Seamless binary upgrade (aka zero downtime upgrade)
  * Mirmon support
  * Full IPv6 support
  * more...

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

PKG := github.com/etix/mirrorbits
GO_LDFLAGS += -X $(PKG)/core.VERSION=$(DEB_VERSION_UPSTREAM)
GO_LDFLAGS += -X $(PKG)/core.BUILD=$(DEB_VERSION)
GO_LDFLAGS += -X $(PKG)/config.TEMPLATES_PATH=/usr/share/mirrorbits
# buildmode=pie is available for riscv64 starting go 1.16
ifeq (,$(filter $(DEB_BUILD_ARCH), mipsel mips64el riscv64))
GO_BUILDFLAGS += -buildmode=pie
endif

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

execute_after_dh_auto_configure:
	cd _build/src/$(PKG) && \
	protoc -I rpc --go_out=plugins=grpc:rpc rpc/rpc.proto

override_dh_auto_build:
	dh_auto_build -- $(GO_BUILDFLAGS) -ldflags '$(GO_LDFLAGS)'
	@sed "s|##PREFIX##|/usr|" \
	  contrib/init/systemd/mirrorbits.service.in \
	  > contrib/init/systemd/mirrorbits.service

override_dh_auto_test:
	dh_auto_test  -- -ldflags '$(GO_LDFLAGS)'

override_dh_auto_install:
	dh_auto_install -- --no-source

execute_after_dh_installexamples:
	rm debian/mirrorbits/usr/share/doc/mirrorbits/examples/init/systemd/.gitignore
	rm debian/mirrorbits/usr/share/doc/mirrorbits/examples/init/systemd/mirrorbits.service.in

## mirrorbits 0.5.1+git20220308.9189dc7+ds1

=== debian/changelog ===
mirrorbits (0.5.1+git20220308.9189dc7+ds1-4ubuntu0.1) mantic-security; urgency=medium

  * No change rebuild due to golang-1.20, golang-1.21 updates

 -- Nishit Majithia <nishit.majithia@canonical.com>  Tue, 23 Jan 2024 10:17:40 +0530

mirrorbits (0.5.1+git20220308.9189dc7+ds1-4build1) mantic; urgency=medium

  * No-change rebuild with Go 1.21.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 24 Aug 2023 17:16:55 +1200

mirrorbits (0.5.1+git20220308.9189dc7+ds1-4) unstable; urgency=medium

  * Bump Standards-Version to 4.6.2 (no changes needed)
  * Add a patch to investigate test failure on armel

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 14 Jul 2023 12:58:14 +0700

mirrorbits (0.5.1+git20220308.9189dc7+ds1-3) unstable; urgency=medium

  * Depend on redis
  * Recommend rsync
  * Suggests geoipupdate
  * Add patch to adjust the default location for GeoIP database
  * Update dependency name: golang-yaml.v2-dev -> golang-gopkg-yaml.v2-dev
  * Create mirrorbits system user

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 14 Jul 2023 08:40:51 +0700

mirrorbits (0.5.1+git20220308.9189dc7+ds1-2) unstable; urgency=medium

  * Replace transitional golang-goprotobuf-dev package
  * Drop patch aimed at compatibility with golang-goprotobuf-dev 1.5.x
  * Fix FTBFS with libprotobuf-dev 3.21.9 (Closes: #1026674)

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 21 Apr 2023 11:20:56 +0700

mirrorbits (0.5.1+git20220308.9189dc7+ds1-1) unstable; urgency=medium

  * Drop patches, applied upstream
  * Drop minor patch level from Standards Version
  * Use dh-sequence-golang, drop --with from dh options
  * Enable buildmode=pie for riscv64
  * Update lintian overrides
  * Add debian/clean to remove the systemd service file
  * Add patch to meet requirements of golang-protobuf 1.5.x

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 18 Jul 2022 14:55:10 +0200

=== debian/control ===
--- 
+++ 
@@ -8,9 +8,10 @@
 Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
- dh-golang,
+ dh-sequence-golang,
  golang-any,
  golang-github-coreos-go-systemd-dev,
+ golang-github-golang-protobuf-1-3-dev,
  golang-github-gomodule-redigo-dev,
  golang-github-howeyc-gopass-dev,
  golang-github-op-go-logging-dev,
@@ -20,9 +21,9 @@
  golang-golang-x-net-dev,
  golang-google-grpc-dev,
  golang-gopkg-tylerb-graceful.v1-dev,
- golang-goprotobuf-dev,
- golang-yaml.v2-dev,
-Standards-Version: 4.6.0.1
+ golang-gopkg-yaml.v2-dev,
+ protoc-gen-go-1-3,
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/mirrorbits
 Vcs-Git: https://salsa.debian.org/debian/mirrorbits.git
 Homepage: https://github.com/etix/mirrorbits
@@ -32,9 +33,16 @@
 Package: mirrorbits
 Architecture: any
 Depends:
+ adduser,
+ redis,
  ${misc:Depends},
  ${shlibs:Depends},
-Built-Using: ${misc:Built-Using}
+Recommends:
+ rsync,
+Suggests:
+ geoipupdate,
+Built-Using:
+ ${misc:Built-Using},
 Description: geographical download redirector
  Mirrorbits is a geographical download redirector written in Go for
  distributing files efficiently across a set of mirrors. It offers a simple and

=== debian/rules ===
--- 
+++ 
@@ -6,17 +6,17 @@
 GO_LDFLAGS += -X $(PKG)/core.VERSION=$(DEB_VERSION_UPSTREAM)
 GO_LDFLAGS += -X $(PKG)/core.BUILD=$(DEB_VERSION)
 GO_LDFLAGS += -X $(PKG)/config.TEMPLATES_PATH=/usr/share/mirrorbits
-# buildmode=pie is available for riscv64 starting go 1.16
-ifeq (,$(filter $(DEB_BUILD_ARCH), mipsel mips64el riscv64))
+ifeq (,$(filter $(DEB_BUILD_ARCH), mipsel mips64el))
 GO_BUILDFLAGS += -buildmode=pie
 endif
 
 %:
-	dh $@ --builddirectory=_build --buildsystem=golang --with=golang
+	dh $@ --builddirectory=_build --buildsystem=golang
 
 execute_after_dh_auto_configure:
 	cd _build/src/$(PKG) && \
-	protoc -I rpc --go_out=plugins=grpc:rpc rpc/rpc.proto
+	find -name "*.pb.go" -delete -printf "removed %p\n" && \
+	protoc -I rpc --go_out=plugins=grpc,Mgoogle/protobuf/empty.proto=github.com/golang/protobuf/ptypes/empty,Mgoogle/protobuf/timestamp.proto=github.com/golang/protobuf/ptypes/timestamp:rpc rpc/rpc.proto
 
 override_dh_auto_build:
 	dh_auto_build -- $(GO_BUILDFLAGS) -ldflags '$(GO_LDFLAGS)'

## mirrorbits 0.5.1+git20240203.4e34d9b+ds1

=== debian/changelog ===
mirrorbits (0.5.1+git20240203.4e34d9b+ds1-1) unstable; urgency=medium

  * Add copyright information for the geoip contrib script
  * Prepend a 'v' to mirrorbits version
  * Fix templates path
  * Add systemd services, drop example from contrib
  * Add a logrotate config file
  * Create the directory /etc/mirrorbits
  * Update README.Debian
  * Add NEWS entry
  * Add basic autopkgtests
  * Install bash completion from contrib
  * Build-Depends: Switch to golang-gopkg-yaml.v3-dev
  * Install a sysusers.d(5) fragment to set up the system user
  * Finalize the NEWS file

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 05 Feb 2024 17:13:24 +0700

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: mirrorbits
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mirrorbits Maintainers <mirrorbits@packages.debian.org>
+Maintainer: Mirrorbits Maintainers <mirrorbits@packages.debian.org>
 Uploaders:
  Arnaud Rebillout <arnaudr@kali.org>,
 Section: net
 Testsuite: autopkgtest-pkg-go
 Priority: optional
 Build-Depends:
+ bash-completion,
  debhelper-compat (= 13),
  dh-sequence-golang,
  golang-any,
@@ -21,7 +21,7 @@
  golang-golang-x-net-dev,
  golang-google-grpc-dev,
  golang-gopkg-tylerb-graceful.v1-dev,
- golang-gopkg-yaml.v2-dev,
+ golang-gopkg-yaml.v3-dev,
  protoc-gen-go-1-3,
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/mirrorbits
@@ -33,11 +33,12 @@
 Package: mirrorbits
 Architecture: any
 Depends:
- adduser,
+ adduser | systemd-sysusers,
  redis,
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
+ logrotate,
  rsync,
 Suggests:
  geoipupdate,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

PKG := github.com/etix/mirrorbits
GO_LDFLAGS += -X $(PKG)/core.VERSION=v$(DEB_VERSION_UPSTREAM)
GO_LDFLAGS += -X $(PKG)/core.BUILD=$(DEB_VERSION)
GO_LDFLAGS += -X $(PKG)/config.TEMPLATES_PATH=/usr/share/mirrorbits/templates/
ifeq (,$(filter $(DEB_BUILD_ARCH), mipsel mips64el))
GO_BUILDFLAGS += -buildmode=pie
endif

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=bash-completion

execute_after_dh_auto_configure:
	cd _build/src/$(PKG) && \
	find -name "*.pb.go" -delete -printf "removed %p\n" && \
	protoc -I rpc --go_out=plugins=grpc,Mgoogle/protobuf/empty.proto=github.com/golang/protobuf/ptypes/empty,Mgoogle/protobuf/timestamp.proto=github.com/golang/protobuf/ptypes/timestamp:rpc rpc/rpc.proto

override_dh_auto_build:
	dh_auto_build -- $(GO_BUILDFLAGS) -ldflags '$(GO_LDFLAGS)'

override_dh_auto_test:
	dh_auto_test  -- -ldflags '$(GO_LDFLAGS)'

override_dh_auto_install:
	dh_auto_install -- --no-source
	# the below step is automatic with debhelper >= 14
	dh_installsysusers

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

=== debian/tests/control ===
Tests: mirrorbits-basic
Restrictions: needs-root

## mirrorbits 0.5.1+git20240729.2c92eee+ds1

=== debian/changelog ===
mirrorbits (0.5.1+git20240729.2c92eee+ds1-3) unstable; urgency=medium

  * Add missing test Depends: redis
  * Add a salsa-ci file

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 25 Nov 2024 10:52:29 +0700

mirrorbits (0.5.1+git20240729.2c92eee+ds1-2) unstable; urgency=medium

  * Install contrib/mirrorbits-* scripts

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 11 Nov 2024 11:09:09 +0700

mirrorbits (0.5.1+git20240729.2c92eee+ds1-1) unstable; urgency=medium

  * Reinstate code generation for the file rpc.proto
  * Downgrade redis to Recommends
  * Bump Standards-Version (no change needed)

 -- Arnaud Rebillout <arnaudr@kali.org>  Thu, 22 Aug 2024 14:33:45 +0700

mirrorbits (0.5.1+git20240203.4e34d9b+ds1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * build against protobuf 1.5 (Closes: #1077366)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 03 Aug 2024 10:39:33 -0400

mirrorbits (0.5.1+git20240203.4e34d9b+ds1-2) unstable; urgency=medium

  * Build-Depends += pkgconf, zlib1g-dev (Closes: #1067366)

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 26 Apr 2024 20:44:36 +0700

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  dh-sequence-golang,
  golang-any,
  golang-github-coreos-go-systemd-dev,
- golang-github-golang-protobuf-1-3-dev,
+ golang-github-golang-protobuf-1-5-dev,
  golang-github-gomodule-redigo-dev,
  golang-github-howeyc-gopass-dev,
  golang-github-op-go-logging-dev,
@@ -22,8 +22,10 @@
  golang-google-grpc-dev,
  golang-gopkg-tylerb-graceful.v1-dev,
  golang-gopkg-yaml.v3-dev,
- protoc-gen-go-1-3,
-Standards-Version: 4.6.2
+ pkgconf,
+ protoc-gen-go-1-5,
+ zlib1g-dev,
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian/mirrorbits
 Vcs-Git: https://salsa.debian.org/debian/mirrorbits.git
 Homepage: https://github.com/etix/mirrorbits
@@ -34,11 +36,11 @@
 Architecture: any
 Depends:
  adduser | systemd-sysusers,
- redis,
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
  logrotate,
+ redis,
  rsync,
 Suggests:
  geoipupdate,
@@ -73,4 +75,5 @@
   * Seamless binary upgrade (aka zero downtime upgrade)
   * Mirmon support
   * Full IPv6 support
+  * If-Modified-Since (RFC-7232) support
   * more...

=== debian/tests/control ===
Tests: mirrorbits-basic-redis
Depends: @, redis
Restrictions: needs-root

## mirrorbits 0.5.1+git20250328.0435651+ds1

=== debian/changelog ===
mirrorbits (0.5.1+git20250328.0435651+ds1-1) unstable; urgency=medium

  * Drop patches applied upstream
  * Drop `Wants/After=redis.service` from systemd services
  * Requirements: allow (and prefer) valkey over redis
  * Rework autopkgtests to test either redis or valkey or none

 -- Arnaud Rebillout <arnaudr@kali.org>  Fri, 28 Mar 2025 22:09:33 +0700

## mirrorbits 0.6

=== debian/changelog ===
mirrorbits (0.6-1) unstable; urgency=medium

  * Update watch file for tagged releases
  * New upstream release [0.6]

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 02 Apr 2025 23:59:45 +0700

=== debian/control ===
--- 
+++ 
@@ -40,8 +40,8 @@
  ${shlibs:Depends},
 Recommends:
  logrotate,
- redis,
  rsync,
+ valkey-server | redis-server,
 Suggests:
  geoipupdate,
 Built-Using:

## mirrorbits 0.6.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-.PHONY: all build dev clean release test installdirs install uninstall install-service uninstall-service service-systemd
+.PHONY: all build dev clean release test installdirs install uninstall install-service uninstall-service service-systemd regen-proto
 
 VERSION := $(shell git describe --always --dirty --tags)
 SHA := $(shell git rev-parse --short HEAD)
@@ -19,7 +19,6 @@
 GOFLAGSDEV := -race -ldflags "$(LDFLAGS) -X $(PACKAGE)/core.DEV=-dev"
 
 GOPATH ?= $(HOME)/go
-PROTOC_GEN_GO := $(GOPATH)/bin/protoc-gen-go
 
 export PATH := $(GOPATH)/bin:$(PATH)
 
@@ -28,20 +27,19 @@
 
 all: build
 
-$(PROTOC_GEN_GO):
-	go get -u github.com/golang/protobuf/protoc-gen-go
-
-rpc/rpc.pb.go: rpc/rpc.proto | $(PROTOC_GEN_GO) $(PROTOC)
+regen-proto: rpc/rpc.proto
 	@ if ! which protoc > /dev/null; then \
 		echo "error: protoc not installed" >&2; \
 		exit 1; \
 	fi
+	go install github.com/golang/protobuf/protoc-gen-go@v1.3.5 && \
+	rm -f rpc/rpc.pb.go && \
 	protoc -I rpc rpc/rpc.proto --go_out=plugins=grpc:rpc
 
-build: rpc/rpc.pb.go
+build:
 	GO111MODULE=on go build $(GOFLAGS) -o $(BINARY) .
 
-dev: rpc/rpc.pb.go
+dev:
 	GO111MODULE=on go build $(GOFLAGSDEV) -o $(BINARY) .
 
 clean:
@@ -52,7 +50,7 @@
 
 release: $(TARBALL)
 
-test: rpc/rpc.pb.go
+test:
 	GO111MODULE=on go test $(GOFLAGS) ./...
 
 installdirs:

=== debian/changelog ===
mirrorbits (0.6.1-1) unstable; urgency=medium

  * New upstream version [0.6.1]
  * Bump standards version (no changes needed)
  * Update FSF address in d/copyright
  * Update my email address
  * Add Static-Built-Using in d/control

 -- Arnaud Rebillout <arnaudr@debian.org>  Sun, 24 Aug 2025 20:58:00 +0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: mirrorbits
 Maintainer: Mirrorbits Maintainers <mirrorbits@packages.debian.org>
 Uploaders:
- Arnaud Rebillout <arnaudr@kali.org>,
+ Arnaud Rebillout <arnaudr@debian.org>,
 Section: net
 Testsuite: autopkgtest-pkg-go
 Priority: optional
@@ -25,7 +25,7 @@
  pkgconf,
  protoc-gen-go-1-5,
  zlib1g-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/mirrorbits
 Vcs-Git: https://salsa.debian.org/debian/mirrorbits.git
 Homepage: https://github.com/etix/mirrorbits
@@ -46,6 +46,8 @@
  geoipupdate,
 Built-Using:
  ${misc:Built-Using},
+Static-Built-Using:
+ ${misc:Static-Built-Using},
 Description: geographical download redirector
  Mirrorbits is a geographical download redirector written in Go for
  distributing files efficiently across a set of mirrors. It offers a simple and

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 execute_after_dh_auto_configure:
 	cd _build/src/$(PKG) && \
 	find -name "*.pb.go" -delete -printf "removed %p\n" && \
-	protoc -I rpc --go_out=plugins=grpc,Mgoogle/protobuf/empty.proto=github.com/golang/protobuf/ptypes/empty,Mgoogle/protobuf/timestamp.proto=github.com/golang/protobuf/ptypes/timestamp:rpc rpc/rpc.proto
+	protoc -I rpc --go_opt=paths=source_relative --go_out=plugins=grpc:rpc rpc.proto
 
 override_dh_auto_build:
 	dh_auto_build -- $(GO_BUILDFLAGS) -ldflags '$(GO_LDFLAGS)'

=== debian/tests/control ===
Tests: mirrorbits-basic
Restrictions: needs-root

Tests: mirrorbits-basic-redis
Restrictions: needs-root
Depends: @, redis-server

Tests: mirrorbits-basic-valkey
Restrictions: needs-root
Depends: @, valkey-server

=== debian/watch ===
version=4
# Use the following to get proper releases
opts=\
filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
searchmode=plain \
https://api.github.com/repos/etix/mirrorbits/git/matching-refs/tags/ \
https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
# Use the following to track git HEAD
#opts="mode=git, pgpmode=none, pretty=0.5.1+git%cd.%h, \
#      dversionmangle=s/\+ds\d*$//, repacksuffix=+ds1" \
#  https://github.com/etix/mirrorbits HEAD
